# coding: utf-8

"""
    Orbipay-Checkout APIs

    API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 

    OpenAPI spec version: 1.0.0
    Contact: checkout.orbipay@alacriti.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CustomerAccount(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'account_id': 'str',
        'nickname': 'str',
        'account_number': 'str',
        'address': 'Address',
        'status': 'str',
        'id_account': 'str',
        'account_holder_name': 'str',
        'url': 'str',
        'custom_fields': 'object',
        'currentBalance': 'str',
        'currentStatemenBalance': 'str',
        'minimumPaymentDue': 'str',
        'pastAmountDue': 'str',
        'paymentDueDate': 'str',
        'statementDate': 'str'
    }

    attribute_map = {
        'id': 'id',
        'account_id': 'account_id',
        'nickname': 'nickname',
        'account_number': 'account_number',
        'address': 'address',
        'status': 'status',
        'id_account': 'id_account',
        'account_holder_name': 'account_holder_name',
        'url': 'url',
        'custom_fields': 'custom_fields',
        'currentBalance': 'currentBalance',
        'currentStatemenBalance': 'currentStatemenBalance',
        'minimumPaymentDue': 'minimumPaymentDue',
        'pastAmountDue': 'pastAmountDue',
        'paymentDueDate': 'paymentDueDate',
        'statementDate': 'statementDate'
    }

    def __init__(self, id=None, account_id=None, nickname=None, account_number=None, address=None, status=None, id_account=None, account_holder_name=None, url=None,
                 custom_fields=None, currentBalance=None, currentStatemenBalance=None, minimumPaymentDue=None, pastAmountDue=None, paymentDueDate=None, statementDate=None):
        """
        CustomerAccountInfo - a model defined in Swagger
        """

        self._id = None
        self._account_id = None
        self._account_holder_name = None
        self._nickname = None
        self._account_number = None
        self._status = None
        self._url = None
        self._address = None
        self._custom_fields = None
        self._id_account = None
        self._currentBalance = None
        self._currentStatemenBalance = None
        self._minimumPaymentDue = None
        self._pastAmountDue = None
        self._paymentDueDate = None
        self._statementDate = None

        self.id = id
        self.account_id = account_id
        self.account_holder_name = account_holder_name
        self.nickname = nickname
        self.account_number = account_number
        self.status = status
        self.url = url
        self.address = address
        self.custom_fields = custom_fields
        self.id_account = id_account
        self.currentBalance = currentBalance
        self.currentStatemenBalance = currentStatemenBalance
        self.minimumPaymentDue = minimumPaymentDue
        self.pastAmountDue = pastAmountDue
        self.paymentDueDate = paymentDueDate
        self.statementDate = statementDate

    @property
    def statementDate(self):
        return self._statementDate

    @statementDate.setter
    def statementDate(self, statementDate):
        self._statementDate = statementDate

    @property
    def paymentDueDate(self):
        return self._paymentDueDate

    @paymentDueDate.setter
    def paymentDueDate(self, paymentDueDate):
        self._paymentDueDate = paymentDueDate

    @property
    def pastAmountDue(self):
        return self._pastAmountDue

    @pastAmountDue.setter
    def pastAmountDue(self, pastAmountDue):
        self._pastAmountDue = pastAmountDue

    @property
    def minimumPaymentDue(self):
        return self._minimumPaymentDue

    @minimumPaymentDue.setter
    def minimumPaymentDue(self, minimumPaymentDue):
        self._minimumPaymentDue = minimumPaymentDue

    @property
    def currentStatemenBalance(self):
        return self._currentStatemenBalance

    @currentStatemenBalance.setter
    def currentStatemenBalance(self, currentStatemenBalance):
        self._currentStatemenBalance = currentStatemenBalance

    @property
    def currentBalance(self):
        return self._currentBalance

    @currentBalance.setter
    def currentBalance(self, currentBalance):
        self._currentBalance = currentBalance

    @property
    def id_account(self):
        return self._id_account

    @id_account.setter
    def id_account(self, id_account):
        self._id_account = id_account

    @property
    def account_number(self):
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        self._account_number = account_number

    @property
    def status(self):
        return self._status

    @status.setter
    def status(self, status):
        self._status = status

    @property
    def url(self):
        return self._url

    @url.setter
    def url(self, url):
        self._url = url

    @property
    def address(self):
        return self._address

    @address.setter
    def address(self, address):
        self._address = address

    @property
    def id(self):
        """
        Gets the id of this CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in OrbiPay-Checkout

        :return: The id of this CustomerAccountInfo.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in OrbiPay-Checkout

        :param id: The id of this CustomerAccountInfo.
        :type: str
        """
        self._id = id

    @property
    def account_id(self):
        """
        Gets the account_id of this CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in partner's system.

        :return: The account_id of this CustomerAccountInfo.
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """
        Sets the account_id of this CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in partner's system.

        :param account_id: The account_id of this CustomerAccountInfo.
        :type: str
        """
        self._account_id = account_id

    @property
    def custom_fields(self):
        """
        Gets the custom_fields of this CustomerAccountInfo.

        :return: The custom_fields of this CustomerAccountInfo.
        :rtype: object
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """
        Sets the custom_fields of this CustomerAccountInfo.

        :param custom_fields: The custom_fields of this CustomerAccountInfo.
        :type: object
        """

        self._custom_fields = custom_fields

    @property
    def account_holder_name(self):
        return self._account_holder_name

    @account_holder_name.setter
    def account_holder_name(self, account_holder_name):
        self._account_holder_name = account_holder_name

    @property
    def nickname(self):
        return self._nickname

    @nickname.setter
    def nickname(self, nickname):
        self._nickname = nickname

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CustomerAccount):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
