# coding: utf-8

"""
    Orbipay-Checkout APIs

    API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 

    OpenAPI spec version: 1.0.0
    Contact: checkout.orbipay@alacriti.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class FundingAccount(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'aba_routing_number': 'str',
        'issuer_name': 'str',
        'account_number': 'str',
        'currency_code3d': 'str',
        'account_type': 'str',
        'account_subtype': 'str',
        'expiry_date': 'str',
        'card_cvv_number': 'str',
        'account_holder_name': 'str',
        'save_for_future_use': 'str',
        'nickname': 'str',
        'url': 'str',
        'status': 'str',
        'address': 'Address',
        'ach_eligible_flag': 'str',
        'atm_eligible_flag': 'str',
        'account_holder_type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'aba_routing_number': 'aba_routing_number',
        'issuer_name': 'issuer_name',
        'account_number': 'account_number',
        'currency_code3d': 'currency_code3d',
        'account_type': 'account_type',
        'account_subtype': 'account_subtype',
        'expiry_date': 'expiry_date',
        'card_cvv_number': 'card_cvv_number',
        'account_holder_name': 'account_holder_name',
        'save_for_future_use': 'save_for_future_use',
        'nickname': 'nickname',
        'url': 'url',
        'status': 'status',
        'address': 'address',
        'ach_eligible_flag': 'ach_eligible_flag',
        'atm_eligible_flag': 'atm_eligible_flag',
        'account_holder_type': 'account_holder_type'
    }

    def __init__(self, id=None, aba_routing_number=None, issuer_name=None, account_number=None, currency_code3d=None, account_type=None, account_subtype=None, expiry_date=None,
                 card_cvv_number=None, account_holder_name=None, address=None, save_for_future_use=None, nickname=None, url=None, status=None, ach_eligible_flag=None,
                 atm_eligible_flag=None, account_holder_type=None):
        """
        FundingAccountInfo - a model defined in Swagger
        """

        self._id = None
        self._aba_routing_number = None
        self._issuer_name = None
        self._account_number = None
        self._currency_code3d = None
        self._account_type = None
        self._account_subtype = None
        self._expiry_date = None
        self._card_cvv_number = None
        self._account_holder_name = None
        self._save_for_future_use = None
        self._nickname = None
        self._url = None
        self._status = None
        self._address = None
        self._ach_eligible_flag = None
        self._atm_eligible_flag = None
        self._account_holder_type = None

        self.id = id
        self.aba_routing_number = aba_routing_number
        self.issuer_name = issuer_name
        self.account_number = account_number
        self.currency_code3d = currency_code3d
        self.account_type = account_type
        self.account_subtype = account_subtype
        self.expiry_date = expiry_date
        self.card_cvv_number = card_cvv_number
        self.account_holder_name = account_holder_name
        self.save_for_future_use = save_for_future_use
        self.nickname = nickname
        self.url = url
        self.status = status
        self.address = address
        self.ach_eligible_flag = ach_eligible_flag
        self.atm_eligible_flag = atm_eligible_flag
        self.account_holder_type = account_holder_type

    @property
    def ach_eligible_flag(self):
        return self._ach_eligible_flag

    @ach_eligible_flag.setter
    def ach_eligible_flag(self, ach_eligible_flag):
        self._ach_eligible_flag = ach_eligible_flag

    @property
    def atm_eligible_flag(self):
        return self._atm_eligible_flag

    @atm_eligible_flag.setter
    def atm_eligible_flag(self, atm_eligible_flag):
        self._atm_eligible_flag = atm_eligible_flag

    @property
    def account_holder_type(self):
        return self._account_holder_type

    @account_holder_type.setter
    def account_holder_type(self, account_holder_type):
        self._account_holder_type = account_holder_type

    @property
    def url(self):
        return self._url

    @url.setter
    def url(self, url):
        self._url = url

    @property
    def status(self):
        return self._status

    @status.setter
    def status(self, status):
        self._status = status

    @property
    def id(self):
        """
        Gets the id of this FundingAccountInfo.
        Id is a unique identifier assigned to the funding account in OrbiPay-Checkout system.

        :return: The id of this FundingAccountInfo.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this FundingAccountInfo.
        Id is a unique identifier assigned to the funding account in OrbiPay-Checkout system.

        :param id: The id of this FundingAccountInfo.
        :type: str
        """
        self._id = id

    @property
    def aba_routing_number(self):
        """
        Gets the aba_routing_number of this FundingAccountInfo.
        ABA Routing Number is mandatory for Bank Accounts.

        :return: The aba_routing_number of this FundingAccountInfo.
        :rtype: str
        """
        return self._aba_routing_number

    @aba_routing_number.setter
    def aba_routing_number(self, aba_routing_number):
        """
        Sets the aba_routing_number of this FundingAccountInfo.
        ABA Routing Number is mandatory for Bank Accounts.

        :param aba_routing_number: The aba_routing_number of this FundingAccountInfo.
        :type: str
        """
        self._aba_routing_number = aba_routing_number

    @property
    def issuer_name(self):
        """
        Gets the issuer_name of this FundingAccountInfo.

        :return: The issuer_name of this FundingAccountInfo.
        :rtype: str
        """
        return self._issuer_name

    @issuer_name.setter
    def issuer_name(self, issuer_name):
        """
        Sets the issuer_name of this FundingAccountInfo.

        :param issuer_name: The issuer_name of this FundingAccountInfo.
        :type: str
        """
        self._issuer_name = issuer_name

    @property
    def account_number(self):
        """
        Gets the account_number of this FundingAccountInfo.
        Account Number field is expected to be a unique field for the accounts in partner system.

        :return: The account_number of this FundingAccountInfo.
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """
        Sets the account_number of this FundingAccountInfo.
        Account Number field is expected to be a unique field for the accounts in partner system.

        :param account_number: The account_number of this FundingAccountInfo.
        :type: str
        """
        self._account_number = account_number

    @property
    def currency_code3d(self):
        """
        Gets the currency_code3d of this FundingAccountInfo.
        3 character ISO currency code should be provided in currencyCode3d field default to USD.

        :return: The currency_code3d of this FundingAccountInfo.
        :rtype: str
        """
        return self._currency_code3d

    @currency_code3d.setter
    def currency_code3d(self, currency_code3d):
        """
        Sets the currency_code3d of this FundingAccountInfo.
        3 character ISO currency code should be provided in currencyCode3d field default to USD.

        :param currency_code3d: The currency_code3d of this FundingAccountInfo.
        :type: str
        """
        self._currency_code3d = currency_code3d

    @property
    def account_type(self):
        """
        Gets the account_type of this FundingAccountInfo.
        Account Type indicates the type of a funding account.

        :return: The account_type of this FundingAccountInfo.
        :rtype: str
        """
        return self._account_type

    @account_type.setter
    def account_type(self, account_type):
        """
        Sets the account_type of this FundingAccountInfo.
        Account Type indicates the type of a funding account.

        :param account_type: The account_type of this FundingAccountInfo.
        :type: str
        """
        #allowed_values = ["bank", "card"]
        #if account_type not in allowed_values:
        #    raise ValueError(
        #        "Invalid value for `account_type` ({0}), must be one of {1}"
        #        .format(account_type, allowed_values)
        #    )

        self._account_type = account_type

    @property
    def account_subtype(self):
        """
        Gets the account_subtype of this FundingAccountInfo.
        'Account Sub Type indicates the sub type of a funding account.'

        :return: The account_subtype of this FundingAccountInfo.
        :rtype: str
        """
        return self._account_subtype

    @account_subtype.setter
    def account_subtype(self, account_subtype):
        """
        Sets the account_subtype of this FundingAccountInfo.
        'Account Sub Type indicates the sub type of a funding account.'

        :param account_subtype: The account_subtype of this FundingAccountInfo.
        :type: str
        """
        #allowed_values = ["savings", "checking", "money_market", "visa_credit", "mastercard_credit", "american_express_credit", "discover_credit", "visa_debit", "mastercard_debit", "discover_debit"]
        #if account_subtype not in allowed_values:
        #    raise ValueError(
        #        "Invalid value for `account_subtype` ({0}), must be one of {1}"
        #        .format(account_subtype, allowed_values)
        #    )

        self._account_subtype = account_subtype

    @property
    def expiry_date(self):
        """
        Gets the expiry_date of this FundingAccountInfo.
        Expiry date of the account is of format mm/yy

        :return: The expiry_date of this FundingAccountInfo.
        :rtype: str
        """
        return self._expiry_date

    @expiry_date.setter
    def expiry_date(self, expiry_date):
        """
        Sets the expiry_date of this FundingAccountInfo.
        Expiry date of the account is of format mm/yy

        :param expiry_date: The expiry_date of this FundingAccountInfo.
        :type: str
        """
        self._expiry_date = expiry_date

    @property
    def card_cvv_number(self):
        """
        Gets the card_cvv_number of this FundingAccountInfo.
        Card CVV/CVV2 number is conditional and needs to be passed when adding or editing a Card as a funding account.

        :return: The card_cvv_number of this FundingAccountInfo.
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """
        Sets the card_cvv_number of this FundingAccountInfo.
        Card CVV/CVV2 number is conditional and needs to be passed when adding or editing a Card as a funding account.

        :param card_cvv_number: The card_cvv_number of this FundingAccountInfo.
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def account_holder_name(self):
        """
        Gets the account_holder_name of this FundingAccountInfo.

        :return: The account_holder_name of this FundingAccountInfo.
        :rtype: str
        """
        return self._account_holder_name

    @account_holder_name.setter
    def account_holder_name(self, account_holder_name):
        """
        Sets the account_holder_name of this FundingAccountInfo.

        :param account_holder_name: The account_holder_name of this FundingAccountInfo.
        :type: str
        """

        self._account_holder_name = account_holder_name

    @property
    def address(self):
        """
        Gets the address of this FundingAccountInfo.

        :return: The address of this FundingAccountInfo.
        :rtype: AddressInfo
        """
        return self._address

    @address.setter
    def address(self, address):
        """
        Sets the address of this FundingAccountInfo.

        :param address: The address of this FundingAccountInfo.
        :type: AddressInfo
        """

        self._address = address

    @property
    def save_for_future_use(self):
        return self._save_for_future_use

    @save_for_future_use.setter
    def save_for_future_use(self, save_for_future_use):
        self._save_for_future_use = save_for_future_use

    @property
    def nickname(self):
        return self._nickname

    @nickname.setter
    def nickname(self, nickname):
        self._nickname = nickname

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, FundingAccount):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
