# coding: utf-8

"""
    Orbipay-Checkout APIs

    API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 

    OpenAPI spec version: 1.0.0
    Contact: checkout.orbipay@alacriti.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Payer(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'customer_id': 'str',
        'middle_name': 'str',
        'first_name': 'str',
        'last_name': 'str',
        'email': 'str',
        'phone_number': 'str',
        'locale':'str',
        'ssn': 'str',
        'url': 'str',
        'status': 'str',
        'address': 'Address'
    }

    attribute_map = {
        'id': 'id',
        'customer_id': 'customer_id',
        'middle_name': 'middle_name',
        'first_name': 'first_name',
        'last_name': 'last_name',
        'email': 'email',
        'phone_number': 'phone_number',
        'locale': 'locale',
        'ssn': 'ssn',
        'url': 'url',
        'status': 'status',
        'address': 'address'
    }

    def __init__(self, id=None, customer_id=None, middle_name=None, first_name=None, last_name=None, email=None, phone_number=None, locale=None, url=None, ssn=None, status=None, address=None):
        """
        CustomerInfo - a model defined in Swagger
        """

        self._id = None
        self._customer_id = None
        self._middle_name = None
        self._first_name = None
        self._last_name = None
        self._email = None
        self._phone_number = None
        self._locale = None
        self._ssn = None
        self._url = None
        self._status = None
        self._address = None

        self.id = id
        self.customer_id = customer_id
        self.middle_name = middle_name
        self.first_name = first_name
        self.last_name = last_name
        self.email = email
        self.phone_number = phone_number
        self.locale = locale
        self.ssn = ssn
        self.url = url
        self.status = status
        self.address = address

    @property
    def locale(self):
        return self._locale

    @locale.setter
    def locale(self, locale):
        self._locale = locale

    @property
    def url(self):
        return self._url

    @url.setter
    def url(self, url):
        self._url = url

    @property
    def ssn(self):
        return self._ssn

    @ssn.setter
    def ssn(self, ssn):
        self._ssn = ssn

    @property
    def status(self):
        return self._status

    @status.setter
    def status(self, status):
        self._status = status

    @property
    def id(self):
        """
        Gets the id of this CustomerInfo.
        Id is a unique identifier with checkout for the customer.

        :return: The id of this CustomerInfo.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this CustomerInfo.
        Id is a unique identifier with checkout for the customer.

        :param id: The id of this CustomerInfo.
        :type: str
        """
        self._id = id

    @property
    def customer_id(self):
        """
        Gets the customer_id of this CustomerInfo.
        Customer Id is a unique identifier in the partner system for the customer.

        :return: The customer_id of this CustomerInfo.
        :rtype: str
        """
        return self._customer_id

    @customer_id.setter
    def customer_id(self, customer_id):
        """
        Sets the customer_id of this CustomerInfo.
        Customer Id is a unique identifier in the partner system for the customer.

        :param customer_id: The customer_id of this CustomerInfo.
        :type: str
        """
        self._customer_id = customer_id

    @property
    def middle_name(self):
        """
        Gets the middle_name of this CustomerInfo.
        Customer Id is a unique identifier in the checkout system for the customer.

        :return: The middle_name of this CustomerInfo.
        :rtype: str
        """
        return self._middle_name

    @middle_name.setter
    def middle_name(self, middle_name):
        """
        Sets the middle_name of this CustomerInfo.
        Customer Id is a unique identifier in the checkout system for the customer.

        :param middle_name: The middle_name of this CustomerInfo.
        :type: str
        """
        self._middle_name = middle_name

    @property
    def first_name(self):
        """
        Gets the first_name of this CustomerInfo.
        Customer's first name

        :return: The first_name of this CustomerInfo.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """
        Sets the first_name of this CustomerInfo.
        Customer's first name

        :param first_name: The first_name of this CustomerInfo.
        :type: str
        """
        self._first_name = first_name

    @property
    def last_name(self):
        """
        Gets the last_name of this CustomerInfo.
        Customer's last name

        :return: The last_name of this CustomerInfo.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """
        Sets the last_name of this CustomerInfo.
        Customer's last name

        :param last_name: The last_name of this CustomerInfo.
        :type: str
        """
        self._last_name = last_name

    @property
    def email(self):
        """
        Gets the email of this CustomerInfo.
        Customer's email address

        :return: The email of this CustomerInfo.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this CustomerInfo.
        Customer's email address

        :param email: The email of this CustomerInfo.
        :type: str
        """
        self._email = email

    @property
    def phone_number(self):
        """
        Gets the phone_number of this CustomerInfo.
        Customer's phone number

        :return: The phone_number of this CustomerInfo.
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """
        Sets the phone_number of this CustomerInfo.
        Customer's phone number

        :param phone_number: The phone_number of this CustomerInfo.
        :type: str
        """
        self._phone_number = phone_number

    @property
    def address(self):
        """
        Gets the address of this CustomerInfo.

        :return: The address of this CustomerInfo.
        :rtype: AddressInfo
        """
        return self._address

    @address.setter
    def address(self, address):
        """
        Sets the address of this CustomerInfo.

        :param address: The address of this CustomerInfo.
        :type: AddressInfo
        """

        self._address = address

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Payer):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
