# coding: utf-8

"""
    Orbipay-Checkout APIs

    API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 

    OpenAPI spec version: 1.0.0
    Contact: checkout.orbipay@alacriti.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PaymentTokenRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'customer_account_reference': 'str',
        'custom_fields': 'object',
        'payment_token': 'PaymentApiToken',
        'fee_amount': 'str'
    }

    attribute_map = {
        'customer_account_reference': 'customer_account_reference',
        'custom_fields': 'custom_fields',
        'payment_token': 'payment_token',
        'fee_amount': 'fee_amount'
    }

    def __init__(self, customer_account_reference=None, custom_fields=None, payment_token=None, fee_amount=None):
        """
        ConfirmChargeRequest - a model defined in Swagger
        """

        self._customer_account_reference = None
        self._custom_fields = None
        self._payment_token = None
        self._fee_amount = None

        self.customer_account_reference = customer_account_reference
        self.custom_fields = custom_fields
        self.payment_token = payment_token
        self.fee_amount = fee_amount

    @property
    def customer_account_reference(self):
        """
        Gets the customer_account_reference of this ConfirmChargeRequest.
        Partner's order reference number for charge.

        :return: The customer_account_reference of this ConfirmChargeRequest.
        :rtype: str
        """
        return self._customer_account_reference

    @customer_account_reference.setter
    def customer_account_reference(self, customer_account_reference):
        """
        Sets the customer_account_reference of this ConfirmChargeRequest.
        Partner's order reference number for charge.

        :param customer_account_reference: The customer_account_reference of this ConfirmChargeRequest.
        :type: str
        """
        self._customer_account_reference = customer_account_reference

    @property
    def custom_fields(self):
        """
        Gets the custom_fields of this ConfirmChargeRequest.

        :return: The custom_fields of this ConfirmChargeRequest.
        :rtype: object
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """
        Sets the custom_fields of this ConfirmChargeRequest.

        :param custom_fields: The custom_fields of this ConfirmChargeRequest.
        :type: object
        """

        self._custom_fields = custom_fields

    @property
    def payment_token(self):
        """
        Sets the payment_token of this ConfirmChargeRequest.

        :param payment_token: The payment_token of this ConfirmChargeRequest.
        :type: str
        """
        return self._payment_token

    @payment_token.setter
    def payment_token(self, payment_token):
        """
        Gets the payment_token of this ConfirmChargeRequest.

        :return: The payment_token of this ConfirmChargeRequest.
        :rtype: str
        """
        self._payment_token = payment_token


    @property
    def fee_amount(self):
        """
        Sets the payment_token of this ConfirmChargeRequest.

        :param payment_token: The payment_token of this ConfirmChargeRequest.
        :type: str
        """
        return self._fee_amount

    @fee_amount.setter
    def fee_amount(self, fee_amount):
        """
        Gets the payment_token of this ConfirmChargeRequest.

        :return: The payment_token of this ConfirmChargeRequest.
        :rtype: str
        """
        self._fee_amount = fee_amount


    
    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PaymentTokenRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
