from __future__ import absolute_import
import logging


class LoggerUtil(object):

    @staticmethod
    def setup_logger(name, level=logging.INFO):
        #print('called setup_logger in ', name)
        """Function setup as many loggers as you want"""
        formatter = logging.Formatter(
            '[%(asctime)s] [%(threadName)s] [%(levelname)s] [%(name)s] [%(funcName)s] {} %(message)s')

        handler = logging.StreamHandler()
        handler.setFormatter(formatter)

        logger = logging.getLogger(name)
        logger.propagate = False
        logger.setLevel(level)
        logger.addHandler(handler)

        return logger
